.586 
.model flat, stdcall
locals
jumps

include       win32api.inc
include       useful.inc
include       s2c.inc

null                 equ    0
int3opcode           equ    0CCh
nopopcode            equ    90h

callopcode           equ    0E8h ;full displacement yakkk (32bit displacement)
jmpopcode            equ    0EBh ;jmp short; 8bit displacement
jccopcode            equ    01110000b ;jcc opcode, 8 bit displacement
jccsigned            equ    80h ;is it forward/backward???
callsigned           equ    80000000h;is it forward/backward?

extrn VirtualAlloc:proc
extrn ExitProcess:proc
extrn MessageBoxA:proc
extrn _wsprintfA:proc
 
.data
                     memptr        dd     ?
                     instrlen      dd     ?
                     format        db     "int 3 at : 0x%x",0
                     mText         db     64     dup(0)
.code
__start:
                     call   VirtualAlloc, null, 1000h, MEM_COMMIT, PAGE_READWRITE
                     mov    memptr, eax
                     call   VirtualAlloc, null, 1000h, MEM_COMMIT, PAGE_READWRITE
                     mov    instrlen, eax

                     mov    ebx, offset   __dummy
                     mov    edi, instrlen
                     
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;First calculate len of instructions
;and find old offset
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__find_len:          call   mlde32, ebx
                     stosd
                     add    ebx, eax
                     cmp    ebx, offset __end_dummy
                     jb     __find_len
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;copy data to buffer and add int 3 after
;each instruction
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__@@1:               mov    edx, instrlen        ;when int len == 0 end of code
                     mov    esi, offset __dummy
                     mov    edi, memptr
__cycle_and_store:   mov    al, int3opcode
                     stosb
                     mov    ecx, dword ptr[edx]
                     rep    movsb
                     add    edx, 4
                     cmp    dword ptr[edx], null
                     jne    __cycle_and_store
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;This is THE rule of this algo
;code starts with int3h and ends with it
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                     mov    al, int3opcode
                     stosb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Now adjust call/jcc/jmp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                     mov    esi, memptr
                     inc    esi    ;skip int 3h
                     mov    edx, instrlen
__cycle_lens:
                     cmp    dword ptr[edx], null
                     je     __@@3
                     cmp    dword ptr[edx], 2     ;is it jcc/jmp opcode len?                     
                     je     __change_jccjmpcall
                     cmp    dword ptr[edx], 5     ;is it call maybe?
                     jne    _@3                   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; check for call/jmp/jcc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__change_jccjmpcall:
                     xor    eax, eax
                     xor    ebx, ebx
                     xor    ecx, ecx
                     lodsb
                     cmp    al, callopcode
                     je     __call
                     cmp    al, jmpopcode
                     je     __jmp_jcc
                     and    al, 11110000b
                     cmp    al, jccopcode
                     je     __jmp_jcc
                     dec    esi     
                     jmp    _@3

__jmp_jcc:
                     xor    eax, eax
                     lodsb
                     ;depending on forward backward I have to calculate offset
                     mov    ebx, edx
                     xor    ecx, ecx
                     push   eax                                             
                     test   al, jccsigned    ; forward or backward???
                     jnz     __jcc_backward
                     add    ebx, 4            
__cycle_for_al_0:
                     cmp    eax, null
                     je     __make_jmp
                     sub    eax, dword ptr[ebx]
                     add    ebx, 4
                     inc    ecx
                     jmp    __cycle_for_al_0

__jcc_backward:
                     neg    al
                     sub    al, 2
                     sub    ebx, 4
__cycle_for_0:
                     cmp    eax, null
                     je     __make_jmp_back
                     sub    eax, dword ptr[ebx]
                     sub    ebx, 4
                     inc    ecx
                     jmp    __cycle_for_0


__make_jmp:
                     pop    eax                                   
                     add    eax, ecx
                     mov    byte ptr[esi-1], al
                     jmp    __suc
__make_jmp_back:
                     pop    eax
                     sub    eax, ecx
                     dec    eax                          ;jmp to int 3h
                     mov    byte ptr[esi-1],al
                     jmp    __suc
  
__call:
                     mov    ebx, edx
                     xor    ecx, ecx
                     lodsd
                     push   eax
                     test   eax, callsigned
                     jnz    __call_backward
                     add    ebx, 4
__cycle_call:
                     cmp    eax, null    
                     je     __make_call
                     sub    eax, dword ptr[ebx]
                     inc    ecx
                     add    ebx, 4
                     jmp    __cycle_call
__call_backward:
                     neg    eax
                     sub    eax, 5
                     sub    ebx, 4
__cycle_call_back:
                     cmp    eax, null
                     je     __make_call_back
                     sub    eax, dword ptr[ebx]
                     sub    ebx, 4
                     inc    ecx
                     jmp    __cycle_call_back

__make_call:
                     pop    eax
                     add    eax, ecx
                     mov    dword ptr[esi-4], eax
                     jmp    __suc
__make_call_back:
                     pop    eax
                     sub    eax, ecx
                     dec    eax                         ;call to int 3h
                     mov    dword ptr[esi-4], eax
                     jmp    __suc
                     
_@3:
                     mov    eax, dword ptr[edx]
                     add    esi, eax
__suc:
                     inc    esi                  ;skip int3 after instruction
                     add    edx, 4
                     jmp    __cycle_lens




__@@3:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                     mov    edx, instrlen
                     xor    ecx, ecx
                     xor    ebx, ebx
                     xor    eax, eax
__len_of_memptr:     inc    ecx
                     add    ecx, dword ptr[edx]
                     add    edx, 4
                     cmp    dword ptr[edx], null
                     jne    __len_of_memptr
                     mov    esi, memptr
                     mov    edi, esi
__crypt_memptr:      lodsb
                     ror    al, 4
                     stosb
                     loop   __crypt_memptr
                                          



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Go to crypted/encrypted code
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__done_crypt:
                     push   offset sehhandle
                     push   dword ptr FS:[0]
                     mov    dword ptr FS:[0], esp
                     jmp    memptr
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Now we have to tace care of every single jmp/call/jcc
;and modify them to right codes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

__dummy:             mov    eax, ebx
                     mov    edx, ecx
                     call   __dummy1
                     mov    edx, 0FFFFFFFFh
                     jmp    __dummy2
                     push   eax
                     mov    eax, dword ptr[esp+4]
                     add    esp, 4
                     
__cont_dummy:        x_push ebx, <hello~>
                     mov    edi, esp
                     x_push ebx, <Yo mY nIgGaZ~>
                     mov    esi, esp
                     push   null
                     push   edi
                     push   esi
                     push   null
                     mov    eax, offset MessageBoxA
                     call   eax                    
                     mov    eax, offset ExitProcess
                     call   eax, null
__dummy3:            ret
                     
__dummy2:            push   eax
                     pop    ebx
                     jmp    __cont_dummy

__dummy1:            call   __dummy3
                     ret
__end_dummy:


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Here is decryptor SEH 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sehhandle     proc C pException:DWORD, pFrame:DWORD, pContext:DWORD, param:DWORD
                     mov    ebx, pContext
                     mov    esi, [ebx.CONTEXT_Eip]   ;esi points to instruction affter int 3h... 
                                                     ;decrypt it and encrypt previous
                     inc    esi
                     mov    edi, esi
__decrypt:           lodsb
                     ror    al, 4
                     stosb
                     cmp    al, int3opcode
                     jne    __decrypt
__encrypt_previous:  ;call   _wsprintfA, offset mText, offset format, [ebx.CONTEXT_Eip]
                     ;call   MessageBoxA, null, offset mText, null, null
                     mov    ebx, pContext
                     inc    [ebx.CONTEXT_Eip]      
                     xor    eax, eax
__exit_seh:          ret    
sehhandle     endp
                     
include       mlde32.asm
end __start
